from model.DateUtils import DateUtils
from model.DataBaseUtils import *
from model.log import logger
from model.CommonUtils import *
du = DateUtils()
log = logger()

def book_rank(start,end,book,stage,type,page,page_size,order_by,order):
    db=MysqlUtils()
    op1=f" and book='{book}'" if book else ''
    op2 = f" and dt>='{start}' " if start else ''
    op3 = f" and dt<='{end}' " if end else ''
    op4 = f" order by {order_by} {order}" if order_by and order else ''
    op5=f" and stage='{stage}'" if stage else ''
    op6=f" and type='{type}'" if type else ''

    sql=f"""select 
concat(DATE_FORMAT(min(dt),'%Y/%m/%d') ,'~',DATE_FORMAT(max(dt),'%Y/%m/%d')) date,
pitcher,book,stage,type,
sum(cost) cost,
sum(view_count) view_count,
sum(click_count) click_count,
round(sum(click_count)/sum(view_count),4) click_rate,
round(sum(cost)*1000/sum(view_count),2) thousand_view_cost,
sum(reg_order_user) reg_user,
sum(reg_order_count) reg_count,
sum(first_order_amount) first_amount,
sum(reg_order_amount) reg_amount,
round(sum(first_order_amount)/sum(cost),4) first_roi,
round(sum(reg_order_amount)/sum(cost),4) roi
from dw_channel where 1=1 {op1} {op2} {op3} {op5} {op6} GROUP BY channel,book,pitcher,stage,type
 {op4}"""
    print(sql)
    return getLimitData(db.dm,sql,page,page_size)



def book_trend(start,end,book,type,platform,page,page_size,order_by,order):
    op1 = f" and book='{book}'" if book else ''
    op2 = f" and type='{type}' " if type else ''
    op3 = f" and platform='{platform}' " if platform else ''
    op4 = f" and dt>='{start}' " if start else ''
    op5 = f" and dt<='{end}' " if end else ''
    op6 = f" order by {order_by} {order}" if order_by and order else ''

    db=MysqlUtils()

    sql=f"""
        select dt,book,type,cost,first_order_amount,reg_order_amount,
            round(first_order_amount/cost,4) first_roi,
            a7,a30,
            round(a7/cost,4) roi7,
            round(a30/cost,4) roi30,
            round(reg_order_amount/cost,4) roi,
            order_amount,
reg_order_amount-cost profit,
round(click_count/view_count,4) click_rate,
round(follow_user/click_count,4) follow_rate,
round(first_order_user/click_count,4) first_order_rate,
view_count,
click_count,
follow_user,
reg_order_user,
first_order_user,
round(cost/follow_user,2) follow_cost,
round(cost/reg_order_user) order_cost,
round(cost/first_order_user) first_order_cost,
concat(a1,',',0,',',a1/cost) d1,
concat(a2-a1,',',(a2-a1)/cost,',',a2/cost) d2,
concat(a3-a2,',',(a3-a2)/cost,',',a3/cost) d3,
concat(a4-a3,',',(a4-a3)/cost,',',a4/cost) d4,
concat(a5-a4,',',(a5-a4)/cost,',',a5/cost) d5,
concat(a6-a5,',',(a6-a5)/cost,',',a6/cost) d6,
concat(a7-a6,',',(a7-a6)/cost,',',a7/cost) d7,
concat(a8-a7,',',(a8-a7)/cost,',',a8/cost) d8,
concat(a9-a8,',',(a9-a8)/cost,',',a9/cost) d9,
concat(a10-a9,',',(a10-a9)/cost,',',a10/cost) d10,
concat(a11-a10,',',(a11-a10)/cost,',',a11/cost) d11,
concat(a12-a11,',',(a12-a11)/cost,',',a12/cost) d12,
concat(a13-a12,',',(a13-a12)/cost,',',a13/cost) d13,
concat(a14-a13,',',(a14-a13)/cost,',',a14/cost) d14,
concat(a15-a14,',',(a15-a14)/cost,',',a15/cost) d15,
concat(a16-a15,',',(a16-a15)/cost,',',a16/cost) d16,
concat(a17-a16,',',(a17-a16)/cost,',',a17/cost) d17,
concat(a18-a17,',',(a18-a17)/cost,',',a18/cost) d18,
concat(a19-a18,',',(a19-a18)/cost,',',a19/cost) d19,
concat(a20-a19,',',(a20-a19)/cost,',',a20/cost) d20,
concat(a21-a20,',',(a21-a20)/cost,',',a21/cost) d21,
concat(a22-a21,',',(a22-a21)/cost,',',a22/cost) d22,
concat(a23-a22,',',(a23-a22)/cost,',',a23/cost) d23,
concat(a24-a23,',',(a24-a23)/cost,',',a24/cost) d24,
concat(a25-a24,',',(a25-a24)/cost,',',a25/cost) d25,
concat(a26-a25,',',(a26-a25)/cost,',',a26/cost) d26,
concat(a27-a26,',',(a27-a26)/cost,',',a27/cost) d27,
concat(a28-a27,',',(a28-a27)/cost,',',a28/cost) d28,
concat(a29-a28,',',(a29-a28)/cost,',',a29/cost) d29,
concat(a30-a29,',',(a30-a29)/cost,',',a30/cost) d30,
concat(a31-a30,',',(a31-a30)/cost,',',a31/cost) d31,
concat(a32-a31,',',(a32-a31)/cost,',',a32/cost) d32,
concat(a33-a32,',',(a33-a32)/cost,',',a33/cost) d33,
concat(a34-a33,',',(a34-a33)/cost,',',a34/cost) d34,
concat(a35-a34,',',(a35-a34)/cost,',',a35/cost) d35,
concat(a36-a35,',',(a36-a35)/cost,',',a36/cost) d36,
concat(a37-a36,',',(a37-a36)/cost,',',a37/cost) d37,
concat(a38-a37,',',(a38-a37)/cost,',',a38/cost) d38,
concat(a39-a38,',',(a39-a38)/cost,',',a39/cost) d39,
concat(a40-a39,',',(a40-a39)/cost,',',a40/cost) d40,
concat(a41-a40,',',(a41-a40)/cost,',',a41/cost) d41,
concat(a42-a41,',',(a42-a41)/cost,',',a42/cost) d42,
concat(a43-a42,',',(a43-a42)/cost,',',a43/cost) d43,
concat(a44-a43,',',(a44-a43)/cost,',',a44/cost) d44,
concat(a45-a44,',',(a45-a44)/cost,',',a45/cost) d45,
concat(a46-a45,',',(a46-a45)/cost,',',a46/cost) d46,
concat(a47-a46,',',(a47-a46)/cost,',',a47/cost) d47,
concat(a48-a47,',',(a48-a47)/cost,',',a48/cost) d48,
concat(a49-a48,',',(a49-a48)/cost,',',a49/cost) d49,
concat(a50-a49,',',(a50-a49)/cost,',',a50/cost) d50,
concat(a51-a50,',',(a51-a50)/cost,',',a51/cost) d51,
concat(a52-a51,',',(a52-a51)/cost,',',a52/cost) d52,
concat(a53-a52,',',(a53-a52)/cost,',',a53/cost) d53,
concat(a54-a53,',',(a54-a53)/cost,',',a54/cost) d54,
concat(a55-a54,',',(a55-a54)/cost,',',a55/cost) d55,
concat(a56-a55,',',(a56-a55)/cost,',',a56/cost) d56,
concat(a57-a56,',',(a57-a56)/cost,',',a57/cost) d57,
concat(a58-a57,',',(a58-a57)/cost,',',a58/cost) d58,
concat(a59-a58,',',(a59-a58)/cost,',',a59/cost) d59,
concat(a60-a59,',',(a60-a59)/cost,',',a60/cost) d60,
concat(m3-a60,',',(m3-a60)/cost,',',m3/cost) m3,
concat(m4-m3,',',(m4-m3)/cost,',',m4/cost) m4,
concat(m5-m4,',',(m5-m4)/cost,',',m5/cost) m5
from book_trend where 1=1  {op1} {op2} {op4} {op5}  {op6} 
"""

    sum_sql=f"""select concat(date_format(min(dt),'%Y/%m/%d'),'~',date_format(max(dt),'%Y/%m/%d')) dt,
sum(cost) cost,
sum(first_order_amount) first_order_amount,
sum(reg_order_amount) reg_order_amount,
round(sum(first_order_amount)/sum(cost),4) first_roi,
round(sum(a7)/sum(cost),4) roi7,
round(sum(a30)/sum(cost),4) roi30,
round(sum(reg_order_amount)/sum(cost),4) roi,
sum(order_amount) order_amount,
sum(reg_order_amount-cost) profit,
round(sum(click_count)/sum(view_count),4) click_rate,
round(sum(follow_user)/sum(click_count),4) follow_rate,
round(sum(first_order_user)/sum(click_count),4) first_order_rate,
sum(view_count) view_count,
sum(click_count) click_count,
sum(follow_user) follow_user,
sum(reg_order_user) reg_order_user,
sum(first_order_user) first_order_user,
round(sum(cost)/sum(follow_user),2) follow_cost,
round(sum(cost)/sum(reg_order_user)) order_cost,
round(sum(cost)/sum(first_order_user)) first_order_cost
from ({sql}) a
"""

    data, total, total_data = getLimitSumData(db.dm, sql, sum_sql, page, page_size)

    def parse(str):
        li=str.split(',')
        li[0]=round(float(li[0]),2)
        li[1]=round(float(li[1]),4)
        li[2]=round(float(li[2]),4)
        return dict(zip(['amount','add','roi'],li))

    # print(data)
    for i in data:
        for k,v in i.items():
            if k in ['d1','d2','d3','d4','d5','d6','d7','d8','d9','d10','d11','d12','d13','d14','d15','d16','d17','d18',
         'd19','d20','d21','d22','d23','d24','d25','d26','d27','d28','d29','d30','d31','d32','d33','d34','d35','d36','d37','d38',
         'd39','d40','d41','d42','d43','d44','d45','d46','d47','d48','d49','d50','d51','d52','d53','d54','d55','d56','d57','d58','d59',
         'd60','m3','m4','m5']:
                i[k]= parse(v) if v else {}

    return data, total, total_data

